<!----------------------------------------------------------------------------------------------------------------------
  -- Request Select
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <BInputGroup size="sm" class="request-select">
        <template v-if="allowCopy" #prepend>
            <BButton class="input-button" :title="copyTitle" @click="copy">
                <Fa icon="copy" />
            </BButton>
        </template>
        <VueSelect
            :id="inputId"
            v-model="innerValue"
            class="input-select"
            :class="{
                'input-select-clearable': clearable,
                'input-select-copy': allowCopy
            }"
            taggable
            :is-clearable="false"
            :options="selectOptions"
            :placeholder="placeholder"
            :disabled="disabled"
            @search="onSearch"
            @search:blur="onSearchBlur"
            @keydown.ctrl.c="copy"
        >
            <template #no-options>
                <slot name="no-options">
                    <div class="p-0 m-0" />
                </slot>
            </template>
        </VueSelect>
        <template v-if="clearable" #append>
            <BButton class="input-button" @click="clear">
                <Fa icon="times" />
            </BButton>
        </template>
    </BInputGroup>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<style lang="scss">
    .request-select {
        flex-wrap: nowrap !important;

        .input-select {
            --vs-input-bg: var(--bs-body-bg);
            --vs-border: var(--bs-border-width) solid var(--bs-border-color);
            --vs-text-color: var(--bs-body-color);
            --vs-input-placeholder-color: var(--bs-secondary-color);

            --vs-menu-offset-top: 2px;
            --vs-menu-bg: var(--bs-body-bg);
            --vs-menu-border: var(--vs-border);

            --vs-option-text-color: var(--bs-body-color);
            --vs-option-selected-color: var(--bs-primary);
            --vs-option-focused-color: var(--bs-secondary-bg);
            --vs-option-bg: var(--bs-body-bg);

            --vs-option-hover-color: var(--bs-tertiary-bg);

            flex: 1 1 auto;
        }
        .input-select-clearable .control {
            border-top-right-radius: 0 !important;
            border-bottom-right-radius: 0 !important;
        }
        .input-select-copy .control {
            border-top-left-radius: 0 !important;
            border-bottom-left-radius: 0 !important;
        }
    }
</style>

<!--------------------------------------------------------------------------------------------------------------------->

<script lang="ts" setup>
    import { computed, ref } from 'vue';

    // Managers
    import clipboardMan from '../../lib/managers/clipboard.js';

    // Components
    import VueSelect from 'vue3-select-component';

    //------------------------------------------------------------------------------------------------------------------
    // Component Definition
    //------------------------------------------------------------------------------------------------------------------

    // TODO: When this is converted to Vue3, the 'value' prop should be changed to 'modelValue' and the 'input' event
    //  should be changed to 'update:modelValue'.

    interface Props
    {
        modelValue ?: string;
        options ?: string[];
        placeholder ?: string;
        disabled ?: boolean;
        allowCopy ?: boolean;
        copyTitle ?: string;
        clearable ?: boolean;
        inputId ?: string;
    }

    const props = withDefaults(defineProps<Props>(), {
        modelValue: undefined,
        options: [] as any,
        placeholder: '',
        disabled: false,
        allowCopy: true,
        copyTitle: 'Copy',
        clearable: true,
        inputId: undefined,
    });

    interface Emits
    {
        (e : 'clear') : void
        (e : 'update:modelValue', value : string) : void
    }

    const emit = defineEmits<Emits>();

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const searchText = ref<string | undefined>(undefined);

    //------------------------------------------------------------------------------------------------------------------
    // Computed
    //------------------------------------------------------------------------------------------------------------------

    const innerValue = computed({
        get() { return props.modelValue; },
        set(val) { emit('update:modelValue', val); },
    });

    const selectOptions = computed(() =>
    {
        return props.options.map((opt) => ({ label: opt, value: opt }));
    });

    //------------------------------------------------------------------------------------------------------------------
    // Methods
    //------------------------------------------------------------------------------------------------------------------

    function clear() : void
    {
        innerValue.value = undefined;
        emit('clear');
    }

    function onSearch(search : string) : void
    {
        searchText.value = search;
    }

    function onSearchBlur() : void
    {
        searchText.value = undefined;
    }

    function copy() : void
    {
        clipboardMan.write(searchText.value || innerValue.value?.toString() || '');
    }
</script>
